#include  "AT91SAM7S256.h"

#include  "stdconst.h"

#include  "sam7s256.h"

#include "d_display.h"
#include "d_button.h"
#include "d_ioctrl.h"
#include "d_timer.h"
#include "d_sound.h"

#define   DISPLAY_HEIGHT      64        // Y pixels
#define   DISPLAY_WIDTH       100       // X pixels

// draw a pixel at x,y
void dSetPixel(UBYTE X,UBYTE Y);
// delete a pixel a x,y
void dClrPixel(UBYTE X,UBYTE Y);
// draw a 4x4 pixel at x,y (display size is adjusted to 16 x 24)
void dSetSuperPixel(UBYTE X,UBYTE Y);
// delete the big pixel
void dClrSuperPixel(UBYTE X,UBYTE Y);

// draw a string on the screen (built-in font is used)
void dDisplayString(UBYTE X,UBYTE Y,UBYTE *pString);
// draw a character at position x,y)
void dDisplayChar(UBYTE On,UBYTE X,UBYTE Y,UBYTE Char);

// delete the screen
void dClearDisplay();
// must be called every 10 ms to update the screen
void dUpdateDisplay();
// must be call at first
void Init();
void Shutdown();

// returns not really a random number :-)
int Rand();
// waits for a specified amount of milli-seconds; spinning
void busyMSleep(int ms);
