.arm
.global enable_interrupts
.func   enable_interrupts
.align  4
enable_interrupts:
                mrs     r0, cpsr
                bic     r0,r0,#0x80
                msr     cpsr_c,r0
                bx      lr
.endfunc

.arm
.global get_and_disable_interrupts
.func   get_and_disable_interrupts
.align  4
get_and_disable_interrupts:
                ands    r0, r0, #0x80
                movne   r0, #0
                bxne    lr
                mrs     r0, cpsr
                orr     r0,r0,#0x80
                msr     cpsr_c,r0
                mov     r0,#1
                bx      lr

.endfunc
.align 4
.equ AIC_EOICR,       (304)
.equ AT91C_BASE_AIC,  (0xFFFFF000)

.arm
.global	timer_isr
.func	timer_isr
.align  4
timer_isr:
	mov	r3, #-1493172224        @ acknolegde pit
	mov	r3, r3, asr #21
	ldr	r1, [r3, #0]
	ldr	r3, =status
    	str	r1, [r3, #0]            @ end save status
    	ldr	r0, =ms_ticks
	ldr	r2, [r0, #0]
	add	r2, r2, #1        	@ inc ms_ticks
   	str	r2, [r0, #0]            @ update ms_ticks
    	ldr	r3, =current_thread_tcb @ load address of current_thread_tcb
    	ldr 	r2, [r3, #0]            @ save old tcp in r3
    	stmfd   r13! , {r2,lr}      	@ save return address for timer_isr (lr)
    	bl      schedule            	@ select next thread for execution
    	ldmia   r13! , {r2,lr}      	@ restore return address for timer_isr (lr)
    	mov     r1,r0               	@ new tcb in r1
    	mov     r0,r2               	@ old tcb in r0
    	mrs     r12 , SPSR          	@ get cpsr of interrupted thread
    	str     r12 , [r0] , #8     @ Store CPSR to TCB point r0 at TCB location for r0 value (post inc)
    	ldmfd   r13! , {r2 , r3}        @ Reload r0/r1 of interrupted thread from stack
    	stmia   r0! , {r2 , r3}         @ store r0/r1 values from TCB, point r0 at TCB location for r2 values
    	ldmfd   r13! , {r2, r3, r12, r14} @reload remaining stacked values 
    	str    	r14  , [r0, #-12]     	@store r14_irq, the interrupted thread restart address
    	stmia   r0  , {r2-r14}^       	@store user r2-r14 
	@ load new thread context
    	ldmia   r1! , {r12, r14}    	@ put interrupted thread's CPSR and return address
    	msr     spsr_fsxc , r12       	@ and restart address in SPSR_irq and r14_irq   
    	ldmia   r1 , {r0-r14}^        	@ load user r0-r14 (this is not r14_irq!) 
    	stmfd   r13! , {r14}
    	ldr     r14, =AT91C_BASE_AIC    @ acknowledge interrupt
    	str     r14, [r14, #AIC_EOICR]
    	ldmia   r13! ,{r14} 		@ restore saved link register (r14_irq)
    	nop
    	movs    pc ,  r14           	@ with SPSR_irq -> CPSR transfer (return to new thread (user mode))
.endfunc

.arm
.global get_cpsr
.func get_cpsr
.align  4
get_cpsr:
    mrs         r0, CPSR
    bx          lr
.endfunc
        
